import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.util.Timer;
import java.util.TimerTask;
import javax.swing.JFrame;
import javax.swing.JLabel;

/**
 * TvNX
 */
public class Dasher {

	/** tHg */
	private static final Font	FONT_24		= new Font(Font.DIALOG, Font.BOLD, 24);
	private static final Font	FONT_80		= new Font(Font.DIALOG, Font.BOLD, 80);
	private static final Font	FONT_200	= new Font(Font.DIALOG, Font.BOLD, 200);

	/** t[ */
	private		JFrame			frame		= null;
	/** Rei */
	private		Container		con			= null;

	/** x */
	private		JLabel			lblHeader	= null;
	private		JLabel			lblData		= null;

	/** tF[Y */
	private		int				phase		= 0;
	/** _ */
	private		int				score		= 0;
	/** JEg_E */
	private		int				countDown	= 0;

	/** L[ */
	private		int				codeKey		= -1;

	/** ̃L[ */
	private		int				keyNext		= 0;

	/** ^C}[ */
	private		Timer			timer		= null;
	/** L[A_v^[ */
	private		KeyAdapter		keyAdapter	= null;

	/**
	 * n܂܂B
	 */
	public static void main(String[] args){
		Dasher sample = new Dasher();
		sample.run();
	}

	/**
	 * RXgN^
	 */
	public Dasher(){

		// superĂяo
		super();

		// t[𐶐
		frame = new JFrame("Dasher 5-8_001");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		// Rei擾
		con = frame.getContentPane();

		// CAEgݒ
		con.setLayout(null);

		// Label𐶐
		lblHeader = new JLabel("TIME:10");
		lblData = new JLabel("PUSH SPACE KEY");
		lblData.setHorizontalAlignment(JLabel.CENTER);
		lblData.setVerticalAlignment(JLabel.CENTER);

		// xzu
		con.add(lblHeader);
		lblHeader.setBounds(0, 00, 100, 16);
		con.add(lblData);
		lblData.setBounds(50, 50, 300, 300);

		// L[A_v^[𐶐
		keyAdapter = new DasherKeyAdapter();
		// L[A_v^[ǉ
		frame.addKeyListener(keyAdapter);

		// TCYœKȃTCYɐݒ
		con.setPreferredSize(new Dimension(400, 400));
		frame.pack();

		// \
		frame.setVisible(true);

		// ^C}[𐶐
		timer = new Timer();
		// ^C}[X^[g
		timer.scheduleAtFixedRate(new DasherTimerTask(), 1, 16);

	} // end Dasher

	/**
	 * s
	 */
	public void run(){

		// tF[Yɕ
		switch(phase){

			// 
			case 0:

				// _
				score = 0;

				// x̏
				lblData.setFont(FONT_24);
				lblData.setText("PUSH SPACE KEY");

				// tF[Y҂Ԃ
				phase = 1;

				// uCN
				break;

			// ҂
			case 1:

				// Xy[XꂽꍇA
				if(codeKey == KeyEvent.VK_SPACE){

					// JEg_E
					countDown = 360;

					// x̏
					lblData.setFont(FONT_80);

					// tF[YJEg_E
					phase = 2;

				} // end if Xy[Xꂽꍇ

				// uCN
				break;

			// JEg_E
			case 2:

				// JEg_E|P
				countDown--;

				lblData.setText(String.valueOf(countDown / 60));

				// JEg_E0ɂȂA
				if(countDown == 0){

					// x̏
					lblData.setFont(FONT_200);

					// XRA
					score = 0;
					// JEg_E
					countDown = 660;

					// ̃L[擾A\
					keyNext = (int)(Math.random() * 10);
					lblData.setText(String.valueOf(keyNext));

					// tF[YQ[
					phase = 3;

				} // end if JEg_E0ɂȂ

				// uCN
				break;

			// Q[
			case 3:

				// L[Ǝ̃L[ꏏ̏ꍇA
				if(codeKey - KeyEvent.VK_0 == keyNext || codeKey - KeyEvent.VK_NUMPAD0 == keyNext ){

					// XRA{POOOO
					score += 10000;

					// ÕL[ꎞIɕێ
					int key0 = keyNext;

					// ̃L[߂
					while(true){

						// ̃L[擾
						keyNext = (int)(Math.random() * 10);

						// L[ႤꍇA
						if(key0 != keyNext){

							// \
							lblData.setText(String.valueOf(keyNext));

							// [v𔲂
							break;

						}

					} // end while ̃L[߂

					// L[
					codeKey = -1;

				} // end if L[Ǝ̃L[ꏏ̏ꍇ

				// JEg_E|P
				countDown--;

				// JEg_E\
				lblHeader.setText("TIME:" + countDown / 60);

				// JEg_E0ɂȂA
				if(countDown == 0){

					// x̏
					lblData.setFont(FONT_24);

					// JEg_E
					countDown = 300;

					// XRA\
					lblData.setText("SCORE:" + score + "!!");

					// tF[YQ[I[o[
					phase = 4;

				} // end if JEg_E0ɂȂ

				// uCN
				break;

			// Q[I[o[
			case 4:

				// JEg_E|P
				countDown--;

				// JEg_E0ɂȂA
				if(countDown == 0){

					// tF[Y
					phase = 0;

				} // end if JEg_E0ɂȂ

				// uCN
				break;

			default:
				// Ȃ
				break;

		} // end swith tF[Yɕ

	} // end run

	/**
	 * L[A_v^[
	 */
	private class DasherKeyAdapter extends KeyAdapter {

		/**
		 * L[̃Cxg
		 */
		@Override
		public void keyPressed(KeyEvent ke){

			// L[R[hێ
			Dasher.this.codeKey = ke.getKeyCode();

		} // end keyPressed

	} // end DasherKeyAdapter

	/**
	 * ^C}[NX
	 */
	private class DasherTimerTask extends TimerTask {

		public void run(){

			// s\bhĂяo
			Dasher.this.run();

		} // end actionPerformed

	} // end DasherTimerTask

}
